;sense ATR and display to LCD	
checkATR:		jb 		IO,checkATR		;(will be 2 first pulses sampled)
sampleATR:		clr 	a		
				mov 	r3,#8			;sample 3 times to confirm bit's level
				nop
				nop
				nop
				nop
				nop
				nop
				nop	
				call	one_etu_96	;delay one bit
sample2ATR:		jnb 	IO,lowATR	;check 1st data bit
				jb  	IO,hiATR	 	;2mc if executed,otherwise 0mc
;======================if low level bit================================
lowATR:
				call	delay_sample56	;	make sure it is
				nop
				nop	
				nop
				nop						;complete 1st 62mc
				call	delay_sample62	;2nd 62mc
				jb		IO,sample2ATR  	;1st sample
low2ATR:		call	delay_sample62	;3rd 62mc
				jb		IO,sample2ATR	;2nd sample

				call	delay_sample62	;4th 62mc
				jb		IO,sample2ATR	;3rd sample

low3ATR:		clr C 					; 1mc
				mov C,IO 				;1mc
				rrc	A				;if low, will @ 251mc after all delay_sample   257
				nop
				nop
				nop
				call	delay_sample56	;5th 62mc
				call	delay_sample56	
				djnz	r3,sample2ATR	;complete one byte
				sjmp	ATR_bytes

;======================if high level bit================================	
hiATR:

			call	delay_sample56		;	make sure it is
			nop
			nop	
		    nop
	    	nop							;complete 1st 62mc
			lcall	delay_sample62		;2nd 62mc
			jnb		IO,sample2ATR  		;1st sample
hi2ATR:		lcall	delay_sample62		;3rd 62mc
			jnb		IO,sample2ATR		;2nd sample

			lcall	delay_sample62		;4th 62mc
			jnb		IO,sample2ATR		;3rd sample
hi3ATR:		clr C 						;1mc
			mov C,IO 					;1mc
			rrc	A						;if low, will @ 251mc after all delay_sample
			nop
			nop
			nop
			lcall	delay_sample56
			call	delay_sample56
			
			djnz	r3,sample2ATR
			sjmp	ATR_bytes 
;----------------------------------------------------------------------------------
;this routine operation occur during guardtime of 9600 baudrate
check_1st_byte:
			cjne	a,#3Bh,ATR_err
			jmp	    ATR_bytes2
ATR_bytes:
/*			cjne	a,#3Bh,ATR_err
			;setb	bit1				;to skip check 3B again
			mov   	a,#0C0H         	;jump to 2nd line
			acall 	LCD_command    		;Send the command
		;	mov   	dptr,#ATR_3B   
		;	acall 	LCD_sendstring    
		    ret
*/			jbc		30h,check_1st_byte
			
ATR_bytes2:
			swap	A									   ;1 mc
			mov		12h,A	  	;back up A to 12h		   ;1 mc
			mov		50h,#00h	;clear RAM address 44h	   ;1 mc
			mov		r0,#50h								   ;1 mc
			xchd	A,@r0		;xchange low order nibble  ;1 mc
			mov		02h,@r0								   ;1 mc
			
		    acall	compare                                ;2 mc
			mov		A,12h		;copy back				   ;1 mc
			swap	A									   ;1 mc
			mov	                                  	50h,#00h							   ;1 mc
			mov		r0,#50h								   ;1 mc
			xchd	A,@r0								   ;1 mc
			mov		02h,@r0								   ;2 mc
			acall	compare								   ;2 mc
			djnz	r6,backup							   ;2 mc		total= 19 mc
			ret

backup:
			nop
			nop
			acall	delayATR
			jmp		checkATR
delayATR:
			mov		r7,#165								;previous value=162
delayATR2:	djnz	r7,delayATR2
			ret

;========================================
ATR_err:  
			mov   	a,#01H         		;clear
			acall 	LCD_command    		;Send the command
			setb	31h
			;call	delay
			call	delay
			call	delay
			mov   	dptr,#my_string30   ;my_string is the label where the string is stored
			acall 	LCD_sendstring    	;Send string 
remove:		call	delay
			call	delay
			;call	delay			
			jb 		p2.2,ATR_err		;wait until user remove the card
			jmp		auto
;========================================

compare:
_1:
			cjne	r2,#1,_2
			mov   	a,#'1'         
		    acall 	LCD_senddata   		
			ret
_2:			cjne	r2,#2,_3
			mov   	a,#'2'         
		    acall 	LCD_senddata   		
			ret
_3:			cjne	r2,#3,_4
			mov   	a,#'3'         
		    acall 	LCD_senddata   		
			ret
_4:			cjne	r2,#4,_5
			mov   	a,#'4'         
		    acall 	LCD_senddata   		
			ret
_5:			cjne	r2,#5,_6
			mov   	a,#'5'         
		    acall 	LCD_senddata   		
			ret
_6:			cjne	r2,#6,_7
			mov   	a,#'6'         
		    acall 	LCD_senddata   		
			ret
_7:			cjne	r2,#7,_8
			mov   	a,#'7'         
		    acall 	LCD_senddata   		
			ret
_8:			cjne	r2,#8,_9
			mov   	a,#'8'         
		    acall 	LCD_senddata   		
			ret
_9:			cjne	r2,#9,_0
			mov   	a,#'9'         
		    acall 	LCD_senddata   		
			ret
_0:			cjne	r2,#00h,_A
			mov   	a,#'0'         
		    acall 	LCD_senddata   		
			ret
_A:			cjne	r2,#0Ah,_B
			mov   	a,#'A'         
		    acall 	LCD_senddata   		
			ret
_B:			cjne	r2,#0Bh,_C
			mov   	a,#'B'         
		    acall 	LCD_senddata   		
			ret
_C:			cjne	r2,#0Ch,_D
			mov   	a,#'C'         
		    acall 	LCD_senddata   		
			ret
_D:			cjne	r2,#0Dh,_E
			mov   	a,#'D'         
		    acall 	LCD_senddata   		
			ret
_E:			cjne	r2,#0Eh,_F
			mov   	a,#'E'         
		    acall 	LCD_senddata   		
			ret
_F:			cjne	r2,#0Fh,ATR_error
			mov   	a,#'F'         
		    acall 	LCD_senddata   		
			ret
ATR_error:
			jmp		ATR_err