;directly sample bit 3 times to confirm the level of bit

;=======================================================================
;==========================status 9600==================================
;status9600 will do sampling the response of smart card in 9600baud
;=======================================================================
status96:					;this routine will sample start bit 
check96:	jb 	IO,check96	;check for low level bit		

sample96:	clr a		
			mov r3,#8	;sample 3 times to confirm bit's level
			nop
			nop
			nop
			nop
			nop
			nop
			call	one_etu_96	;delay one bit
sample296:	jnb 	IO,low96	;check 1st data bit
			jb  	IO,hi96	 	;2mc if executed,otherwise 0mc
;======================if low level bit================================
;low96 will sample low level bit of response by 3 times
low96:
			call	delay_sample56;	make sure it is
			nop
			nop	
			nop
			nop					;complete 1st 62mc
			call	delay_sample62	;2nd 62mc
			jb		IO,sample296  	;1st sample
low296:		call	delay_sample62	;3rd 62mc
			jb		IO,sample296	;2nd sample
			call	delay_sample62	;4th 62mc
			jb		IO,sample296	;3rd sample
low396:		clr 	C ; 1mc
			mov 	C,IO ;1mc
			rrc		A	;if low, will @ 251mc after all delay_sample   257
			nop
			nop
			nop
			call	delay_sample56	;5th 62mc
			call	delay_sample56	
			djnz	r3,sample296	;complete one byte
			sjmp	check_status


;======================if high level bit================================
;hi96 will sample low level bit of response by 3 times	
hi96:

			call	delay_sample56;	make sure it is
			nop
			nop	
		    nop
	    	nop					;complete 1st 62mc
			call	delay_sample62	;2nd 62mc
			jnb		IO,sample296  	;1st sample
hi296:		call	delay_sample62	;3rd 62mc
			jnb		IO,sample296	;2nd sample
			call	delay_sample62	;4th 62mc
			jnb		IO,sample296	;3rd sample
hi396:		clr C ;1mc
			mov C,IO ;1mc
			rrc	A	;if low, will @ 251mc after all delay_sample
			nop
			nop
			nop

			call	delay_sample56
			call	delay_sample56
			djnz	r3,sample296
			sjmp	check_status 
;================================check status routine================================
		
check_status:
			cjne 	a,#090H,wait_byte_60h
			clr		OK
			call	delay
			setb	OK
			call 	delay
			clr		OK
			mov		r7,a			;for test purpose
			jb		28h,ret_back
			mov   	a,#0C0H         ;01H is command for clearing LCD
			call 	LCD_command    	;Send the command
			mov   	dptr,#my_string5   ;9000
			lcall 	LCD_sendstring    ;Send string
			ret
ret_back:
			ret

wait_byte_60h:
			cjne	a,#60h,acknowledge_byte1E	;erase all checksum
			mov		18H,#35	;45	;		save number to r0 bank 3
wait:		djnz	18h,wait
			jmp		status38

	

acknowledge_byte1E:
			cjne	a,#1EH,acknowledge_byte34	;storage for acknowledge byte
			mov		18H,#44					;save number to r0 bank 3
wait2:		djnz	18h,wait2
			jmp		status38	

acknowledge_byte34:
			cjne	a,#34H,erase_checksum_status	;storage for acknowledge byte
			mov		18H,#44					;save number to r0 bank 3
wait3:		djnz	18h,wait3
			jmp		status38
							
erase_checksum_status:
			cjne	a,#21h,write_checksum_status 	;erase all checksum
			mov		r7,a					;for test purpose
			jb		28h,ret_back
			mov   a,#0C0H         
			lcall LCD_command    			;Send the command
			mov   dptr,#my_string24   		;21 5C 90 00
			lcall LCD_sendstring    		;Send string
			ret
write_checksum_status:
			cjne	a,#6EH,evenodd_checksum_status
			mov		r7,a		;for test purpose
			jb		28h,ret_back
		    mov   a,#0C0H         
			lcall LCD_command    ;Send the command
			mov   dptr,#my_string25   ;6E 37 90 00
			call LCD_sendstring    ;Send string
			ret
evenodd_checksum_status:
			cjne	a,#66H,fail_6100
			mov   a,#0C0H        		 ;01H is command for clearing LCD
			lcall LCD_command   		 ;Send the command
			mov   dptr,#my_string26  	 ;66 6F 90 00
			lcall LCD_sendstring    	 ;Send string
			mov		r7,a				 ;for test purpose
			ret

fail_6100:
			cjne	a,#61h,fail_6D00
			clr		xOK
			mov   a,#0C0H         
			call LCD_command    			
			mov   dptr,#my_string42   		
			lcall LCD_sendstring    		
			ret

fail_6D00:	cjne	a,#6DH,unrecognized_response
			clr		xOK
			call	delay
			setb	xOK
			call delay
			clr		xOK
		;	acall	delay
		;	setb	xOK
			mov	r7,a		;
			mov   a,#0C0H         ;01H is command for clearing LCD
			lcall LCD_command    ;Send the command
			mov   dptr,#my_string6   ;6D00
			lcall LCD_sendstring    ;Send string
			nop
			ret
unrecognized_response:
			clr		xOK
			call	delay
		;	call	delay
			setb	xOK
			call delay
		;	call	delay
			clr		OK
			call	delay
		;	call	delay
			setb	OK
			clr		xOK
			mov   a,#01H        	 	;01H is command for clearing LCD
			call LCD_command    		;Send the command
			mov   dptr,#my_string22  	
			lcall LCD_sendstring    	
			ret
;================================check status routine end================================

;==================delay==========================
delay:		   ;delay for status LED to light up
	mov r7,#255
load:
	mov r6,#255
;load_1:
;	mov r7,255
delay1:
	djnz r6,delay1
;	djnz r6,load_1
	djnz r7,load
	ret
;==================delay 62mc======================
delay_sample62:
			mov		r4,#28
			nop
cont62:		djnz	r4,cont62;10mc
			ret		;total=62mc	including calling func

;==================delay 56mc======================
delay_sample56:
			mov		r4,#25
			nop
cont56:		djnz	r4,cont56;10mc
			ret		;total=56mc

;==================delay 10mc======================
delay_sample10:
			mov		r4,#2
			nop
cont10:		djnz	r4,cont10;10mc
			ret		;total=56mc

;===================================================
one_etu_96:
			mov  	r4,#180
			nop
etu96:		djnz 	r4,etu96
			ret
;======================================================================
;============================status 38k baudrate=======================
;======================================================================
;it applied 93mc per etu
;sampling time calculated as 90mc/6=15mc with additional 3mc

status38:  
check38:    jb 		IO,check38

sample38:	clr		a
			mov 	r3,#8
			nop
			nop;;
			nop;;
			nop;;
			nop;;
			call	one_etu_38 ;complete start bit
sample238:	jnb 	IO,low38
			jb		IO,hi38
;======================if low level bit================================
low38:
			call	delay_sample13;	make sure it is complete 1st 13mc + 2mc jnb
			call	delay_sample15	;2nd 15mc
			jb		IO,sample238  	;1st sample
			;jnb	IO,low296		;sample 2nd time
low238:		call	delay_sample15	;3rd 15mc
			jb		IO,sample238	;2nd sample
			call	delay_sample15	;4th 15mc
			jb		IO,sample238	;3rd sample

low338:	
			mov 	C,IO ;1mc
			rrc		A	;if low, will @ 63mc after all delay_sample

			call	delay_sample11	 ;5th 15mc
			call	delay_sample13

			djnz	r3,sample238	 ;complete one byte
			jmp		check_status
;======================if high level bit================================	
hi38:
			call	delay_sample13;	make sure it is complete 1st 13mc + 2mc jb
			call	delay_sample15	;2nd 15mc
			jnb		IO,sample238  	;1st sample																																		                                    
hi238:		call	delay_sample15	;3rd 15mc
			jnb		IO,sample238	;2nd sample
			call	delay_sample15	;4th 15mc
			jnb		IO,sample238	;3rd sample

hi338:	;	clr C	;1mc
			mov 	C,IO ;1mc
			rrc		A	;if hi, will @ 63mc after all delay_sample
			call	delay_sample11	 ;5th 15mc
			call	delay_sample13
			djnz	r3,sample238	 ;complete one byte										                                                                                                                            
			jmp		check_status

one_etu_38:
			mov	r4,#41	 ;preserved:42
etu38:		djnz r4,etu38 ;42 X 2=84
			ret

delay_sample15:
			mov r4,#5
cont15:		djnz r4,cont15;	
			ret

delay_sample13:
			mov r4,#4
cont13:		djnz r4,cont13
		    ret
delay_sample11:
			mov r4,#3
cont11:		djnz r4,cont11
			ret

;======================================================================
;======================================================================
;============================status 115k baudrate======================
;======================================================================
;it applied 31mc per etu
;sampling time calculated as 30/6 =5mc delay with additional 1mc
/*
status115:
check115:   jb IO,check115

sample115:	clr	a		;start bit delay
			mov r3,#8
			;nop
			lcall	one_etu_115
sample2115:	jnb IO,low115 ;start sample data bits
			jb	IO,hi115
;======================if low level bit================================
low115:
			lcall	delay_sample5;	make sure it is complete 1st 5mc
			nop
			nop
			nop
			;acall	delay_sample5	;2nd 5mc
			jb		IO,sample2115  	;1st sample
			;jnb	IO,low296		;sample 2nd time
			nop
			nop
			nop
low2115:	;acall	delay_sample5	;3rd 5mc
			jb		IO,sample2115	;2nd sample
			;acall	delay_sample5	;4th 5mc
			nop
			nop
			nop
			jb		IO,sample2115	;3rd sample
low3115:	clr C		;1mc
			mov C,IO	;1mc
			rrc	A	;if low, will be @ 22mc after all delay_sample
			;nop
			nop
			nop
			lcall	delay_sample5	 ;5th 15mc
			djnz	r3,sample2115	 ;complete one byte
			jmp	check_status
;======================if high level bit================================	
hi115:
			lcall	delay_sample5;	make sure it is complete 1st 5mc
			nop
			nop
			nop
			;acall	delay_sample5	;2nd 5mc
			jnb		IO,sample2115  	;1st sample
			;jnb	IO,low296		;sample 2nd time
			nop
			nop
			nop
hi2115:		;acall	delay_sample5	;3rd 5mc
			jnb		IO,sample2115	;2nd sample
			;acall	delay_sample5	;4th 5mc
			nop
			nop
			nop
			jnb		IO,sample2115	;3rd sample
hi3115:		clr C	;1mc
			mov C,IO ;1mc
			rrc	A	;if low, will @ 22mc after all delay_sample
			;nop
			nop
			nop
			lcall	delay_sample5	 ;5th 15mc
			djnz	r3,sample2115	 ;complete one byte
			jmp		check_status
;=======================================================================
one_etu_115:
			mov	r4,#12
etu115:		djnz r4,etu115 ;12 X 2=24
			ret

delay_sample5:
			nop	
			ret
*/
